package info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh;

import info.aspirecn.rdc.aspirecloud.node.except.annotations.EnableAspireCloudRdcHandleExcept;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.netflix.eureka.EnableEurekaClient;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.core.env.Environment;
import org.springframework.util.StopWatch;

/**
 * @author jianggang
 * @date  2018/10/25 15:49:24
 */

@SpringBootApplication
@EnableAspireCloudRdcHandleExcept
@Slf4j
@EnableEurekaClient
@EnableFeignClients(basePackages={"info.aspirecn.rdc","info.aspirecn.iov.sjjh"})
@ComponentScan("info.aspirecn.rdc.aspirecloud.node.except")
@ComponentScan("info.aspirecn.rdc.aspirecloud.node.brave")
public class Application {
    public static void main(String[] args) {
        StopWatch watch = new StopWatch();
        watch.start();
        ApplicationContext context = SpringApplication.run(Application.class, args);
        Environment environment = context.getBean(Environment.class);
        String applicationName = environment.getProperty("spring.application.name");
        watch.stop();
        log.info("{} 启动完毕，times={}s", applicationName, watch.getTotalTimeSeconds());
    }
}
