package info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.action;

import info.aspirecn.iov.sjjh.commons.lang.ChannelTypeHandleResponseObject;
import info.aspirecn.iov.sjjh.commons.lang.Constant;
import info.aspirecn.rdc.aspirecloud.node.except.utils.ErrorUtils;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.service.TelecomOnlineTimeService;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh_interface.action.TelecomOnlineTimeActionI;
import lombok.extern.slf4j.Slf4j;
import org.apache.tomcat.util.codec.binary.Base64;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;

/**
 * @author jianggang
 * @Date 2019/6/10 18:02:26
 * @Description
 */
@Slf4j
@RestController
public class TelecomOnlineTimeAction implements TelecomOnlineTimeActionI {

    @Autowired
    private TelecomOnlineTimeService telecomOnlineTimeService;

    @Override
    public ChannelTypeHandleResponseObject telecomOnlineTime(
            @RequestHeader(value = "channelId", required = true) String channelId,
            @RequestHeader(value = "ifJkCode", required = false) String ifJkCode,
            @RequestParam(value = "outTime", required = false) Integer outTime,
            @RequestParam(value = "customBody", required = true) String customBody) {
        log.info("------------------->电信在网时长：channelId:{},ifJkCode:{},outTime:{},customBody：{}",
                channelId,
                ifJkCode,
                outTime,
                channelId);
        HttpServletRequest request = ((ServletRequestAttributes) (RequestContextHolder.currentRequestAttributes())).getRequest();
        /**设置上游返回码日志记录-默认*/
        request.setAttribute(Constant.LOG_UPSTREAM_RESPONSE_CODE, Constant.LOG_UPSTREAM_DEFAULT_RESPONSE_CODE);
        /**设置日志记录通道请求类型为同步*/
        request.setAttribute(Constant.CHANNEL_TYPE_KEY, Constant.CHANNEL_TYPE_SYNC);
        ChannelTypeHandleResponseObject res = telecomOnlineTimeService.callTelecomOnlineTime(request, channelId, ifJkCode, outTime, customBody);
        /**日志记录是否计费*/
        request.setAttribute(Constant.ACCESSLOG_MG_ISCHARGE_KEY, res.getIsCharge());
        /**日志记录通道响应码*/
        if(Constant.SUCCESS == res.getCode()){
            request.setAttribute(Constant.ACCESSLOG_MG_RESPONSE_CODE_KEY,Constant.CHANNEL_LOG_SUCCESS_CODE);
        }else{
            request.setAttribute(Constant.ACCESSLOG_MG_RESPONSE_CODE_KEY,Constant.CHANNEL_LOG_ERROR_CODE);
        }
        /**日志记录通道customBody*/
        try {
            request.setAttribute(Constant.CHANNEL_LOG_QUERY,Base64.encodeBase64String(customBody.getBytes("utf-8")));
        } catch (Exception e) {
            ErrorUtils.captureException(e);
            e.printStackTrace();
        }
        return res;
    }
}
