package info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.test.action;

import com.fasterxml.jackson.databind.ObjectMapper;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.Application;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.vo.CompanyInfoRequestObject;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.vo.DrivingLicenseJsonResolveObject;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh_interface.vo.CustomBodyObject;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.test.context.web.WebAppConfiguration;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.test.web.servlet.request.MockMvcRequestBuilders;
import org.springframework.test.web.servlet.result.MockMvcResultHandlers;
import org.springframework.test.web.servlet.result.MockMvcResultMatchers;
import org.springframework.test.web.servlet.setup.MockMvcBuilders;
import org.springframework.web.context.WebApplicationContext;

import java.util.HashMap;
import java.util.Map;

@RunWith(SpringRunner.class)
@SpringBootTest(classes = Application.class)
@WebAppConfiguration
public class ActonTest {
    private MockMvc mockMvc;

    @Autowired
    private WebApplicationContext context;
    @Autowired
    private ObjectMapper objectMapper;


    @Before
    public void before() throws Exception {
        mockMvc = MockMvcBuilders.webAppContextSetup(context).build();
    }

    @Test
    public void checkIdCardForBTY() throws Exception {
        CompanyInfoRequestObject companyInfoRequestObject = new CompanyInfoRequestObject();
        String channelId = "1000001";
        companyInfoRequestObject.setCname("");
        companyInfoRequestObject.setCnumber("");
        companyInfoRequestObject.setOrgNumber("");
        companyInfoRequestObject.setRegNumber("");

        String customBody = objectMapper.writeValueAsString(companyInfoRequestObject);
        mockMvc.perform(
                MockMvcRequestBuilders.post("/companyInfo.do")
                        .header("channelId",channelId)
                        .param("outTime", "1000")
                        .param("customBody", customBody)
        )
                .andExpect(MockMvcResultMatchers.status().isOk())
                .andDo(MockMvcResultHandlers.print());

    }

    @Test
    public void drivingLicenseAction() throws Exception {
        DrivingLicenseJsonResolveObject drivingLicenseJsonResolveObject = new DrivingLicenseJsonResolveObject();
        String channelId = "1000001";
        drivingLicenseJsonResolveObject.setIdCode("41xexstesfss");
        drivingLicenseJsonResolveObject.setName("chen");
        drivingLicenseJsonResolveObject.setPlateNumber("1111");
        String customBody = objectMapper.writeValueAsString(drivingLicenseJsonResolveObject);
        mockMvc.perform(
                MockMvcRequestBuilders.post("/drivingLicense.do")
                        .header("channelId",channelId)
                        .param("outTime", "1000")
                        .param("customBody", customBody)
        )
                .andExpect(MockMvcResultMatchers.status().isOk())
                .andDo(MockMvcResultHandlers.print());

    }
    @Test
    public void faceCheckForYH() throws Exception {
        DrivingLicenseJsonResolveObject drivingLicenseJsonResolveObject = new DrivingLicenseJsonResolveObject();
        String channelId = "1000001";
        drivingLicenseJsonResolveObject.setIdCode("41xexstesfss");
        drivingLicenseJsonResolveObject.setName("chen");
        drivingLicenseJsonResolveObject.setPlateNumber("1111");
        String customBody = objectMapper.writeValueAsString(drivingLicenseJsonResolveObject);
        mockMvc.perform(
                MockMvcRequestBuilders.post("/faceCheckForYH.do")
                        .header("channelId",channelId)
                        .param("outTime", "1000")
                        .param("customBody", customBody)
        )
                .andExpect(MockMvcResultMatchers.status().isOk())
                .andDo(MockMvcResultHandlers.print());

    }
    @Test
    public void faceCheckWZDecode() throws Exception {
        String channelId = "1000001";
        Map<String,String> requestParam=new HashMap<String,String>();
        requestParam.put("params","");
        String customBody = objectMapper.writeValueAsString(requestParam);
        mockMvc.perform(
                MockMvcRequestBuilders.post("/faceCheckWZDecode.do")
                        .header("channelId",channelId)
                        .param("outTime", "1000")
                        .param("customBody", customBody)
        )
                .andExpect(MockMvcResultMatchers.status().isOk())
                .andDo(MockMvcResultHandlers.print());

    }
    @Test
    public void foreignInvest() throws Exception {
        String channelId = "1000001";
        Map<String,String> requestParam=new HashMap<String,String>();
        requestParam.put("cname","");
        String customBody = objectMapper.writeValueAsString(requestParam);
        mockMvc.perform(
                MockMvcRequestBuilders.post("/foreignInvest.do")
                        .header("channelId",channelId)
                        .param("outTime", "1000")
                        .param("customBody", customBody)
        )
                .andExpect(MockMvcResultMatchers.status().isOk())
                .andDo(MockMvcResultHandlers.print());

    }

    @Test
    public void identityCardTwoPointCheck() throws Exception {
        String channelId = "1000001";
        Map<String,String> requestParam=new HashMap<String,String>();
        requestParam.put("name","");
        requestParam.put("idCode","");
        String customBody = objectMapper.writeValueAsString(requestParam);
        mockMvc.perform(
                MockMvcRequestBuilders.post("/identityCardTwoPointCheck.do")
                        .header("channelId",channelId)
                        .param("outTime", "1000")
                        .param("customBody", customBody)
        )
                .andExpect(MockMvcResultMatchers.status().isOk())
                .andDo(MockMvcResultHandlers.print());

    }


    @Test
    public void identityCardTwoWeiZhongDecode() throws Exception {
        String channelId = "1000001";
        Map<String,String> requestParam=new HashMap<String,String>();
        requestParam.put("params","");
        String customBody = objectMapper.writeValueAsString(requestParam);
        mockMvc.perform(
                MockMvcRequestBuilders.post("/identityCardTwoWeiZhongDecode.do")
                        .header("channelId",channelId)
                        .param("outTime", "1000")
                        .param("customBody", customBody)
        )
                .andExpect(MockMvcResultMatchers.status().isOk())
                .andDo(MockMvcResultHandlers.print());

    }

    @Test
    public void telecomOnlineStatus() throws Exception {
        String channelId = "1000001";
        Map<String,String> requestParam=new HashMap<String,String>();
        requestParam.put("phone","");
        String customBody = objectMapper.writeValueAsString(requestParam);
        mockMvc.perform(
                MockMvcRequestBuilders.post("/telecomOnlineStatus.do")
                        .header("channelId",channelId)
                        .param("outTime", "1000")
                        .param("customBody", customBody)
        )
                .andExpect(MockMvcResultMatchers.status().isOk())
                .andDo(MockMvcResultHandlers.print());

    }


    @Test
    public void telecomOnlineTime() throws Exception {
        String channelId = "1000001";
        Map<String,String> requestParam=new HashMap<String,String>();
        requestParam.put("phone","");
        String customBody = objectMapper.writeValueAsString(requestParam);
        mockMvc.perform(
                MockMvcRequestBuilders.post("/telecomOnlineTime.do")
                        .header("channelId",channelId)
                        .param("outTime", "1000")
                        .param("customBody", customBody)
        )
                .andExpect(MockMvcResultMatchers.status().isOk())
                .andDo(MockMvcResultHandlers.print());

    }


    @Test
    public void getVehicleViolationInfo() throws Exception {
        String channelId = "1000001";
        Map<String,String> requestParam=new HashMap<String,String>();
        requestParam.put("carCode","");
        requestParam.put("carDriverNumber","");
        requestParam.put("carType","");
        String customBody = objectMapper.writeValueAsString(requestParam);
        mockMvc.perform(
                MockMvcRequestBuilders.post("/getVehicleViolationInfo.do")
                        .header("channelId",channelId)
                        .param("outTime", "1000")
                        .param("customBody", customBody)
        )
                .andExpect(MockMvcResultMatchers.status().isOk())
                .andDo(MockMvcResultHandlers.print());

    }

    @Test
    public void checkIdCardForYH() throws Exception {
        String channelId = "1000001";
        Map<String,String> requestParam=new HashMap<String,String>();
        requestParam.put("name","");
        requestParam.put("idCode","");
        String customBody = objectMapper.writeValueAsString(requestParam);
        mockMvc.perform(
                MockMvcRequestBuilders.post("/checkIdCardForYH.do")
                        .header("channelId",channelId)
                        .param("outTime", "1000")
                        .param("customBody", customBody)
        )
                .andExpect(MockMvcResultMatchers.status().isOk())
                .andDo(MockMvcResultHandlers.print());

    }


    @Test
    public void checkLocationForYH() throws Exception {
        String channelId = "1000001";
        Map<String,String> requestParam=new HashMap<String,String>();
        requestParam.put("name","");
        requestParam.put("idCode","");
        String customBody = objectMapper.writeValueAsString(requestParam);
        mockMvc.perform(
                MockMvcRequestBuilders.post("/checkLocationForYH.do")
                        .header("channelId",channelId)
                        .param("outTime", "1000")
                        .param("customBody", customBody)
        )
                .andExpect(MockMvcResultMatchers.status().isOk())
                .andDo(MockMvcResultHandlers.print());

    }
    @Test
    public void lianTongCheck() throws Exception {
        String channelId = "1000001";
        Map<String,String> requestParam=new HashMap<String,String>();
        requestParam.put("name","");
        requestParam.put("idCode","");
        requestParam.put("mobile","");
        String customBody = objectMapper.writeValueAsString(requestParam);
        mockMvc.perform(
                MockMvcRequestBuilders.post("/y00-lianTongCheck.do")
                        .header("channelId",channelId)
                        .param("outTime", "1000")
                        .param("customBody", customBody)
        )
                .andExpect(MockMvcResultMatchers.status().isOk())
                .andDo(MockMvcResultHandlers.print());

    }


}
