package info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.test.service;

import com.fasterxml.jackson.databind.ObjectMapper;
import info.aspirecn.iov.sjjh.commons.lang.ChannelTypeHandleResponseObject;
import info.aspirecn.iov.sjjh.commons.lang.Constant;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.service.CompanyInfoService;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.service.DrivingLicenseService;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.vo.CompanyInfoRequestObject;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.vo.DrivingLicenseJsonResolveObject;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.vo.ForeignInvestResponseObject;
import lombok.extern.slf4j.Slf4j;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.mock.web.MockHttpServletRequest;
import org.springframework.test.context.junit4.SpringRunner;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.Application;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

/**
 * @Auther chenqingqing
 * @Date 2018/11/19 14:33:50
 * @Description
 */

@RunWith(SpringRunner.class)
@SpringBootTest(classes = Application.class)
@Slf4j
public class BTYChannelServiceTest {

    @Autowired
    CompanyInfoService companyInfoService;

    @Autowired
    DrivingLicenseService drivingLicenseService;

    @Test
    public void companyInfoTest() throws IOException {
        Map<String,String> customBodyObject=new HashMap<String,String>();
        customBodyObject.put("cname","");
        customBodyObject.put("cnumber","");
        customBodyObject.put("orgNumber","");
        customBodyObject.put("regNumber","");
        ObjectMapper mapper = new ObjectMapper();
        String customBodyString = mapper.writeValueAsString(customBodyObject);

        MockHttpServletRequest request = new MockHttpServletRequest();
        request.addHeader(Constant.CUSTOMER_RETURN_TYPE_PARA,1);
        ChannelTypeHandleResponseObject responseObject = companyInfoService.companyInfo(request,10000,customBodyString);
        log.info("responseObject========>{}",responseObject.toString());
        Assert.assertEquals((int)responseObject.getCode(),Constant.SUCCESS);
        Assert.assertEquals((int)responseObject.getIsCharge(),Constant.INTERFACE_QUERY_FEE);
    }
    @Test
    public void checkIdCardWeiZhongTest() throws IOException {
        DrivingLicenseJsonResolveObject drivingLicenseJsonResolveObject = new DrivingLicenseJsonResolveObject();
        drivingLicenseJsonResolveObject.setName("江港");
        drivingLicenseJsonResolveObject.setIdCode("421022199701017517");
        drivingLicenseJsonResolveObject.setPlateNumber("");
        ObjectMapper mapper = new ObjectMapper();
        String customBodyString = mapper.writeValueAsString(drivingLicenseJsonResolveObject);

        MockHttpServletRequest request = new MockHttpServletRequest();
        request.addHeader(Constant.CUSTOMER_RETURN_TYPE_PARA,1);
        ChannelTypeHandleResponseObject responseObject = drivingLicenseService.drivingLicense(request,customBodyString,10000);
        log.info("responseObject========>{}",responseObject.toString());
        Assert.assertEquals((int)responseObject.getCode(),Constant.SUCCESS);
        Assert.assertEquals((int)responseObject.getIsCharge(),Constant.INTERFACE_QUERY_FEE);
    }
}
