package info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.action;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import info.aspirecn.iov.sjjh.commons.lang.ChannelTypeHandleResponseObject;
import info.aspirecn.iov.sjjh.commons.lang.Constant;
import info.aspirecn.rdc.aspirecloud.node.except.utils.ErrorUtils;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.service.FaceCheckService;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh_interface.action.FaceCheckActionI;
import lombok.extern.slf4j.Slf4j;
import org.apache.tomcat.util.codec.binary.Base64;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;
import java.io.UnsupportedEncodingException;


/**
 * @author jianggang
 * @Date 2019/6/10 14:24:47
 * @Description
 */

@Slf4j
@RestController
public class FaceCheckAction implements FaceCheckActionI {


    @Autowired
    private FaceCheckService faceCheckService;

    @Override
    public ChannelTypeHandleResponseObject faceCheck(@RequestHeader(value = "channelId", required = true) String channelId,
                                                     @RequestHeader(value = "ifJkCode", required = false) String ifJkCode,
                                                     @RequestParam(name = "outTime",required = false) Integer outTime,
                                                     @RequestBody String customBody) {
        JSONObject paramObject = JSON.parseObject(customBody);
        paramObject.put("photo", "base64");
        log.info("---------->云海人像对比请求：channelId：{}，ifJkCode：{},outTime：{}, customBody：{}",
                channelId,
                ifJkCode,
                outTime,
                paramObject);
        HttpServletRequest request = ((ServletRequestAttributes) (RequestContextHolder.currentRequestAttributes())).getRequest();
        /**设置日志记录通道请求类型为同步*/
        request.setAttribute(Constant.CHANNEL_TYPE_KEY, Constant.CHANNEL_TYPE_SYNC);
        /**设置上游返回码日志记录-默认*/
        request.setAttribute(Constant.LOG_UPSTREAM_RESPONSE_CODE, Constant.LOG_UPSTREAM_DEFAULT_RESPONSE_CODE);
        ChannelTypeHandleResponseObject res = faceCheckService.callFaceCheck(request, channelId, ifJkCode, outTime, customBody);
        /**日志记录是否计费*/
        request.setAttribute(Constant.ACCESSLOG_MG_ISCHARGE_KEY, res.getIsCharge());
        /**日志记录通道响应码*/
        if(Constant.SUCCESS == res.getCode()){
            request.setAttribute(Constant.ACCESSLOG_MG_RESPONSE_CODE_KEY,Constant.CHANNEL_LOG_SUCCESS_CODE);
        }else{
            request.setAttribute(Constant.ACCESSLOG_MG_RESPONSE_CODE_KEY,Constant.CHANNEL_LOG_ERROR_CODE);
        }
        /**日志记录通道customBody*/
        try {
            log.info("photoIdentityCheck.actionBase64={}", Base64.encodeBase64String(paramObject.toJSONString().getBytes("utf-8")));
            request.setAttribute(Constant.CHANNEL_LOG_QUERY,
                    Base64.encodeBase64String(paramObject.toJSONString().getBytes("utf-8")));
        } catch (Exception ex) {
            ErrorUtils.captureException(ex);
        }
        return res;
    }

    @Override
    public ChannelTypeHandleResponseObject faceCheckWZDecode(@RequestHeader(value = "channelId", required = true) String channelId,
                                                     @RequestHeader(value = "ifJkCode", required = false) String ifJkCode,
                                                     @RequestParam(name = "outTime",required = false) Integer outTime,
                                                     @RequestBody String customBody) {
        HttpServletRequest request = ((ServletRequestAttributes) (RequestContextHolder.currentRequestAttributes())).getRequest();
        /**设置日志记录通道请求类型为同步*/
        request.setAttribute(Constant.CHANNEL_TYPE_KEY, Constant.CHANNEL_TYPE_SYNC);
        /**设置上游返回码日志记录-默认*/
        request.setAttribute(Constant.LOG_UPSTREAM_RESPONSE_CODE, Constant.LOG_UPSTREAM_DEFAULT_RESPONSE_CODE);
        ChannelTypeHandleResponseObject res = faceCheckService.faceCheckWZDecode(request, channelId, ifJkCode, outTime, customBody);
        /**日志记录是否计费*/
        request.setAttribute(Constant.ACCESSLOG_MG_ISCHARGE_KEY, res.getIsCharge());
        /**日志记录通道响应码*/
        if(Constant.SUCCESS == res.getCode()){
            request.setAttribute(Constant.ACCESSLOG_MG_RESPONSE_CODE_KEY,Constant.CHANNEL_LOG_SUCCESS_CODE);
        }else{
            request.setAttribute(Constant.ACCESSLOG_MG_RESPONSE_CODE_KEY,Constant.CHANNEL_LOG_ERROR_CODE);
        }
        return res;
    }
}
